package me.flashyreese.mods.sodiumextra.mixin.particle;

import me.flashyreese.mods.sodiumextra.client.SodiumExtraClientMod;
import net.minecraft.class_2394;
import net.minecraft.class_2398;
import net.minecraft.class_4184;
import net.minecraft.class_703;
import net.minecraft.class_761;
import net.minecraft.class_765;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(class_761.class)
public class MixinWorldRenderer {

    @Inject(method = "tickRainSplashing", at = @At(value = "HEAD"), cancellable = true)
    public void tickRainSplashing(class_4184 camera, CallbackInfo callbackInfo) {
        if (!(SodiumExtraClientMod.options().particleSettings.particles && SodiumExtraClientMod.options().particleSettings.rainSplash)) {
            callbackInfo.cancel();
        }
    }

    @Inject(method = "renderWeather", at = @At(value = "HEAD"), cancellable = true)
    private void renderWeather(class_765 manager, float f, double d, double e, double g, CallbackInfo callbackInfo) {
        if (!(SodiumExtraClientMod.options().detailSettings.rainSnow)) {
            callbackInfo.cancel();
        }
    }

    @Inject(method = "spawnParticle(Lnet/minecraft/particle/ParticleEffect;ZZDDDDDD)Lnet/minecraft/client/particle/Particle;", at = @At(value = "INVOKE", target = "Lnet/minecraft/client/render/WorldRenderer;getRandomParticleSpawnChance(Z)Lnet/minecraft/client/option/ParticlesMode;"), cancellable = true)
    private void spawnParticle(class_2394 parameters, boolean alwaysSpawn, boolean canSpawnOnMinimal, double x, double y, double z, double velocityX, double velocityY, double velocityZ, CallbackInfoReturnable<class_703> callbackInfo) {
        if (SodiumExtraClientMod.options().particleSettings.particles) {
            if (!SodiumExtraClientMod.options().particleSettings.explosion) {
                if (parameters == class_2398.field_11221 || parameters == class_2398.field_11236 || parameters == class_2398.field_11203) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.water) {
                if (parameters == class_2398.field_11210) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.smoke) {
                if (parameters == class_2398.field_11251 || parameters == class_2398.field_11237 || parameters == class_2398.field_17430 || parameters == class_2398.field_17431) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.potion) {
                if (parameters == class_2398.field_11226 || parameters == class_2398.field_11225 || parameters == class_2398.field_11245 || parameters == class_2398.field_11213 || parameters == class_2398.field_11249) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.portal) {
                if (parameters == class_2398.field_11214 || parameters == class_2398.field_23190) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.drip) {
                if (parameters == class_2398.field_11232 || parameters == class_2398.field_18306 || parameters == class_2398.field_11223 ||
                        parameters == class_2398.field_18304 || parameters == class_2398.field_18305 || parameters == class_2398.field_20534 ||
                        parameters == class_2398.field_20535 || parameters == class_2398.field_20536 || parameters == class_2398.field_20537 ||
                        parameters == class_2398.field_22446 || parameters == class_2398.field_22447 || parameters == class_2398.field_22448) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.firework) {
                if (parameters == class_2398.field_11248) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.bubble) {
                if (parameters == class_2398.field_11247 || parameters == class_2398.field_11241 || parameters == class_2398.field_11238 ||
                        parameters == class_2398.field_11243) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.redstone) {
                if (parameters == class_2398.field_11212) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.environment) {
                if (parameters == class_2398.field_22247 || parameters == class_2398.field_22248 || parameters == class_2398.field_22249 || parameters == class_2398.field_23956) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.villagers) {
                if (parameters == class_2398.field_11231 || parameters == class_2398.field_11211) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.villagers) {
                if (parameters == class_2398.field_11231 || parameters == class_2398.field_11211) {
                    callbackInfo.setReturnValue(null);
                }
            }
            if (!SodiumExtraClientMod.options().particleSettings.composter) {
                if (parameters == class_2398.field_17741) {
                    callbackInfo.setReturnValue(null);
                }
            }
        } else {
            callbackInfo.setReturnValue(null);
        }
    }
}
